use ducklang::parser::ast::build_ast;
use std::{env, fs::File, io::Read};

pub fn main() {
    for arg in env::args().skip(1) {
        let mut f = File::open(&arg).unwrap_or_else(|_| panic!("file {} not found", arg));
        let mut content = String::new();
        f.read_to_string(&mut content)
            .unwrap_or_else(|_| panic!("Error in reading file {}", arg));
        build_ast(&content).expect("parsing failed");
        println!("{} is a valid ducklang program", arg);
    }
}
